# __ASG_TypesMetaModel.py_____________________________________________________
from ASG import *
from ATOM3Type       import *
from ATOM3String import *
class ASG_TypesMetaModel(ASG, ATOM3Type):

   def __init__(self, parent= None, ASGroot = None):
      ASG.__init__(self, 'TypesMetaModel', ASGroot, ['ASG_TypesMetaModel' ,'TypeName' ,'LeafType' ,'Operator'])

      ATOM3Type.__init__(self)
      self.parent = parent
      self.Author=ATOM3String('')
      self.Comments=ATOM3String('')
      self.generatedAttributes = {'Author': ('ATOM3String', ),
                                  'Comments': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Author').grid(row=0,column=0,sticky=W)
      self.Author.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Author', 0, 2)
      Label(self.containerFrame, text='Comments').grid(row=1,column=0,sticky=W)
      Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.Comments)).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Comments', 1, 2)
      #from ATOM3 import *
      #a = ATOM3 (parentWindowInfo , 'TypesMetaModel')
      #a.grid(row=2,column=0, columnspan = 2, sticky=W)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Author.toString()+' '+self.Comments.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Author.getValue(),self.Comments.getValue(),)

   def setValue(self, value):
      self.Author.setValue(value[0])
      self.Comments.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Author.writeConstructor2File(file, indent, objName+'.Author', depth, generatingCode)
      self.Comments.writeConstructor2File(file, indent, objName+'.Comments', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Author.writeValue2File(file, indent, objName+'.Author', depth, generatingCode)
      self.Comments.writeValue2File(file, indent, objName+'.Comments', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Author.invalid() or self.Comments.invalid() 

   def clone(self):
      return self
      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Author = other.Author
      self.Comments = other.Comments
   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.destroyNodes()
      self.Author.destroy()
      self.Comments.destroy()
      self.containerFrame = None
   def open(self, parent, topWindowParent):
       from ATOM3 import *
       a = ATOM3(topWindowParent, 'TypesMetaModel', 0, 1, self)
       #self.writeContents(a)
       return a
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


