from GraphGrammarEdit import *
from GGruleEdit import *

def savedTrans(self):
   self.EditingGraphGrammar= GraphGrammarEdit(None, self)
   self.EditingGraphGrammar.Name=ATOM3String('TypeCodeGen')
   self.EditingGraphGrammar.Rules=ATOM3List([ 1, 1, 1, 0],GGruleEdit,None, self)
   lcobj0=[]
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('TupleGen')
   cobj0.Order=ATOM3Integer(1)

   from ASG_TypesMetaModel import *
   from Operator import *
   from TypeName import *
   from LeafType import *

   cobj0.LHS = ASG_TypesMetaModel(self)

   self.obj22=Operator(self)

   self.obj22.type.setValue( (['X', 'U', '->'], 0) )
   self.obj22.type.config = 0
   self.obj22.GGLabel.setValue(1)
   self.obj22.graphClass_= graph_Operator
   if self.genGraphics:
      from graph_Operator import *
      new_obj = graph_Operator(208.0,271.0,self.obj22)
   else: new_obj = None
   self.obj22.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj22)
   cobj0.RHS = ASG_TypesMetaModel(self)

   self.obj24=Operator(self)

   self.obj24.type.setValue( (['X', 'U', '->'], 0) )
   self.obj24.type.config = 0
   self.obj24.GGLabel.setValue(1)
   self.obj24.graphClass_= graph_Operator
   if self.genGraphics:
      from graph_Operator import *
      new_obj = graph_Operator(205.0,255.0,self.obj24)
   else: new_obj = None
   self.obj24.graphObject_ = new_obj
   self.obj240= AttrCalc()
   self.obj240.Copy=ATOM3Boolean()
   self.obj240.Copy.setValue(('Copy from LHS', 1))
   self.obj240.Copy.config = 0
   self.obj240.Specify=ATOM3Constraint()
   self.obj240.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj24.GGset2Any['type']= self.obj240
   cobj0.RHS.addNode(self.obj24)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\nif node.FILE_: 		# This node has been processed yet!\n  return 0\nself.generatedChilds = []\nfor child in node.out_connections_:# childs have the FILE_ slot filled...\n  if child.FILE_:	# if this is the case, add to list\n     self.generatedChilds.append(child)\n  else:\n     return 0	        # otherwise, the condition does not hold...\nreturn 1		\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '"action performed when the rule is applied "\nnnode = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\n# compose the class name\nclassName = ""\ncounter = 0\nattributesInfo = []							# list to be passed to the generateCode4Product function\nfor node in self.generatedChilds:					# for each child that has been found...\n   if counter > 0: className = className+"X"\n   if node.getClass() == \'LeafType\':\n      className = className + node.Type.getValue()[0]		# append the name of the element\n      val = node.Type.getValue()\n      attributesInfo.append((val[0], \'ATOM3\'+val[1], val[2], node))\n   else:\n      className = className + node.FILE_\n      attributesInfo.append((node.FILE_, node.FILE_, None, node))\n   counter = counter + 1\nprint "performing action! className = ", className\nnnode.FILE_=className\nfileName = className+".py"\nfile = open(atom3i.codeGenDir +"/"+fileName, "w+t")			\nfile.write("from Tkinter import *\\n")					\nfile.write("from ATOM3Type import *\\n")\n# generate imports...\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("from "+type+" import *\\n")\nfile.write("class "+className+" (ATOM3Type):\\n")\nfile.write("   def __init__(self):\\n")\n# .........................................................\n# Generate the __init__ method\n# .........................................................\nfile.write("      ATOM3Type.__init__(self)\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("      self."+name+"= None\\n")			# for the moment, initialize to None...\nfile.write("\\n")\n# .........................................................\n# Generate the createComponents method\n# .........................................................\nfile.write("   def createComponents(self):\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("      if not self."+name+":\\n")\n   if node.getClass() == \'LeafType\':                               # we are dealing with a simple type...\n       node.Type.initialValue.writeConstructor2File(file,"         ", "self."+name, 0, 1)\n   else:\n       file.write("         from "+name+" import *\\n")		# import the class...\n       file.write("         self."+name+"="+type+"()\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the show method\n# .........................................................\nfile.write("   def show(self, parent, parentWindowInfo=None):\\n")\nfile.write("      self.createComponents()\\n")\nfile.write("      ATOM3Type.show(self, parent, parentWindowInfo)\\n")\nfile.write("      self.containerFrame = Frame(parent)\\n")\ncounter = 0\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   if node.getClass() == "LeafType":\n      directEditing = node.Type.getValue()[4][1]\n   else:\n      directEditing = 1\n   file.write("      Label(self.containerFrame, text=\'"+name+"\').grid(row="+str(counter)+",column=0,sticky=W)\\n")\n   if directEditing:\n      file.write("      self."+name+".show(self.containerFrame, parentWindowInfo).grid(row="+str(counter)+",column=1,sticky=W)\\n")\n   else:\n      file.write("      Button( self.containerFrame, text = \'edit\', ")\n      file.write("command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x."+name+"))")\n      file.write(".grid(row="+str(counter)+",column=1,sticky=W)\\n")\n   counter = counter + 1\nfile.write("      return self.containerFrame\\n\\n")\n# .........................................................\n# Generate the toString method\n# .........................................................\nfile.write("   def toString(self):\\n")\nfile.write("      self.createComponents()\\n")\nfile.write("      return ")\ncounter = 0\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   if counter: file.write("+\' \'+")\n   file.write(" self."+name+".toString()")\n   counter = counter + 1\nfile.write("\\n")\n# .........................................................\n# Generate the getValue method\n# .........................................................\nfile.write("   def getValue(self):\\n")\nfile.write("      self.createComponents()\\n")\nfile.write("      return (")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("self."+name+".getValue(),")\nfile.write(")\\n\\n")\n# .........................................................\n# Generate the setValue method\n# .........................................................\nfile.write("   def setValue(self, value):\\n")\nfile.write("      self.createComponents()\\n")\nfile.write("      if value == None:\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("         self."+name+".setNone()\\n")\nfile.write("      else:\\n")\ncounter = 0\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("         self."+name+".setValue(value["+str(counter)+"])\\n")\n   counter = counter + 1\nfile.write("\\n")\n# .........................................................\n# Generate the writeConstructor2File method\n# .........................................................\nfile.write(\'   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):\\n\')\nfile.write("      self.createComponents()\\n")\nfile.write("      file.write(indent+objName+\'= "+className+"()\\\\n\')\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write("      self."+name+".writeConstructor2File(file, indent, objName+\'."+name+"\', depth, generatingCode)\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the writeValue2File method\n# .........................................................\nfile.write(\'   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):\\n\')\nfile.write("      self.createComponents()\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n  name, type, valInitial, node = element                         # unpack element components\n  file.write("      self."+name+".writeValue2File(file, indent, objName+\'."+name+"\', depth, generatingCode)\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the clone method\n# .........................................................\nfile.write(\'   def clone(self):\\n\')\nfile.write(\'     "Makes an exact copy of itself"\\n\')\nfile.write(\'     cloneObject = \'+className+\'()\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write(\'     if self.\'+name+\': cloneObject.\'+name+\' = self.\'+name+\'.clone()\\n\')\nfile.write(\'     return cloneObject\\n\')\n# .........................................................\n# Generate the destroy method\n# .........................................................\nfile.write(\'   def destroy(self):\\n\')\nfile.write(\'     "Destroys (i.e. updates) each field"\\n\')\nfile.write(\'     cloneObject = \'+className+\'()\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write(\'     if self.\'+name+\': self.\'+name+\'.destroy()\\n\')\nfile.write(\'     return cloneObject\\n\')\n# .........................................................\n# Generate the invalid method\n# .........................................................\nfile.write(\'   def invalid(self):\\n\')\nfile.write(\'     "checks whether the entity is valid or not"\\n\')\nfile.write(\'     inval = 0\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write(\'     if self.\'+name+\': inval = inval or self.\'+name+\'.invalid()\\n\')   \nfile.write(\'     return inval\\n\\n\')\nfile.close()\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('UnionGen')
   cobj0.Order=ATOM3Integer(1)

   from ASG_TypesMetaModel import *
   from Operator import *
   from TypeName import *
   from LeafType import *

   cobj0.LHS = ASG_TypesMetaModel(self)

   self.obj29=Operator(self)

   self.obj29.type.setValue( (['X', 'U', '->'], 1) )
   self.obj29.type.config = 0
   self.obj29.GGLabel.setValue(1)
   self.obj29.graphClass_= graph_Operator
   if self.genGraphics:
      from graph_Operator import *
      new_obj = graph_Operator(215.0,300.0,self.obj29)
   else: new_obj = None
   self.obj29.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj29)
   cobj0.RHS = ASG_TypesMetaModel(self)

   self.obj31=Operator(self)

   self.obj31.type.setValue( (['X', 'U', '->'], 1) )
   self.obj31.type.config = 0
   self.obj31.GGLabel.setValue(1)
   self.obj31.graphClass_= graph_Operator
   if self.genGraphics:
      from graph_Operator import *
      new_obj = graph_Operator(226.0,344.0,self.obj31)
   else: new_obj = None
   self.obj31.graphObject_ = new_obj
   self.obj310= AttrCalc()
   self.obj310.Copy=ATOM3Boolean()
   self.obj310.Copy.setValue(('Copy from LHS', 1))
   self.obj310.Copy.config = 0
   self.obj310.Specify=ATOM3Constraint()
   self.obj310.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj31.GGset2Any['type']= self.obj310
   cobj0.RHS.addNode(self.obj31)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\nif node.FILE_: 						# This node has been processed yet!\n   return 0\n\nself.generatedChilds = []\nfor child in node.out_connections_:			# All childs must have the FILE_ slot filled...\n   if child.FILE_:					# if this is the case, add to list\n      self.generatedChilds.append(child)\n   else:\n      return 0						# otherwise, the condition does not hold...\nreturn 1	\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '"action performed when the rule is applied "\nnnode = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\n# compose the class name\nclassName = ""\ncounter = 0\nattributesInfo = []\nfor node in self.generatedChilds:					# for each child that has been found...\n   if counter > 0: className = className+"U"\n   if node.getClass() == \'LeafType\':\n      className = className + node.Type.getValue()[0]		# append the name of the element\n      val = node.Type.getValue()\n      attributesInfo.append((val[0], \'ATOM3\'+val[1], val[2], node))\n   else:\n      className = className + node.FILE_\n      attributesInfo.append((node.FILE_, node.FILE_, None, node))\n   counter = counter + 1\nprint "performing action! className = ", className\nind = "     "\nnnode.FILE_=className\nfileName = className+".py"\nfile = open(atom3i.codeGenDir+"/"+fileName, "w+t")			\nfile.write("from Tkinter import *\\n")					\nfile.write("from ATOM3Type import *\\n")\n# generate imports...\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write("from "+type+" import *\\n")\nfile.write("class "+className+" (ATOM3Type):\\n")\nfile.write("   def __init__(self):\\n")\n# .........................................................\n# Generate the __init__ method\n# .........................................................\nfile.write(ind+"ATOM3Type.__init__(self)\\n")\nfile.write(ind+"self.optMenu = None\\n")\nfile.write(ind+"self.selected= None\\n")\nfile.write(ind+"self.lastSelected= None\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"self."+name+"= None\\n")			# for the moment, initialize to None...\nfile.write("\\n")\n# .........................................................\n# Generate the createComponents method\n# .........................................................\nfile.write("   def createComponents(self):\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"if not self."+name+":\\n")\n   if node.getClass() == \'LeafType\': # we are dealing with a simple type...\n      node.Type.initialValue.writeConstructor2File(file,ind+"   ", "self."+name, 0, 1)\n   else:\n      file.write(ind+"   from "+name+" import *\\n")		# import the class...\n      file.write(ind+"   self."+name+"="+type+"()\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the show method\n# .........................................................\nfile.write("   def show(self, parent, parentWindowInfo=None):\\n")\nfile.write(ind+"ATOM3Type.show(self, parent, parentWindowInfo)\\n")\nfile.write(ind+"self.createComponents()\\n")\nfile.write(ind+"self.showParent = parent\\n")\nfile.write(ind+"self.parentWindowInfo = parentWindowInfo\\n")\nfile.write(ind+"self.selected = StringVar()\\n")\nfile.write(ind+"if not self.lastSelected:\\n")\n# make 1st element selected...\nname, type, valInitial, node = attributesInfo[0]\nfile.write(ind+"   self.selected.set(\'"+name+"\')\\n")\nfile.write(ind+"else:\\n")\nfile.write(ind+"   self.selected.set(self.lastSelected)\\n")\n\nfile.write(ind+"self.label = None\\n")\nfile.write(ind+"self.widget = None\\n")\nfile.write(ind+"self.containerFrame = Frame(parent)\\n")\nfile.write(ind+"Label(self.containerFrame, text=\'Select Attribute\').grid(row=0,column=0,sticky=W)\\n")\nfile.write(ind+"self.optMenu = OptionMenu(self.containerFrame, self.selected")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(",\'"+name+"\'")\nfile.write(")\\n")\nfile.write(ind+"self.selected.trace_variable( \'w\', self.valueChanged)\\n")\nfile.write(ind+"self.optMenu.grid(row=0,column=1,sticky=W)\\n")\ncounter = 0\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   if counter == 0:\n      file.write(ind+"if self.lastSelected == \'"+name+"\':\\n")\n   else:\n      file.write(ind+"elif self.lastSelected == \'"+name+"\':\\n")\n   file.write(ind+"      self.destroyAllBut(self."+name+")\\n")\n   file.write(ind+"      self.show"+name+"(self.showParent, self.parentWindowInfo)\\n")\nfile.write(ind+"return self.containerFrame\\n\\n")\n# .........................................................\n# Generate the valueChanged method\n# .........................................................\nfile.write("   def valueChanged(self, param1, param2, param3):\\n")\ncounter = 0\nfile.write(ind+"value = self.selected.get()\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   if counter == 0:\n      file.write(ind+"if value == \'"+name+"\':\\n")\n   else:\n      file.write(ind+"elif value == \'"+name+"\':\\n")\n   file.write(ind+"   if self.lastSelected != \'"+name+"\':\\n")\n   file.write(ind+"      self.destroyAllBut(self."+name+")\\n")\n   file.write(ind+"      self.show"+name+"(self.showParent, self.parentWindowInfo)\\n")\n# .........................................................\n# Generate the destroyAllBut method\n# .........................................................\nfile.write("   def destroyAllBut(self, survivor):\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"if survivor != self."+name+":\\n")\n   file.write(ind+"   self."+name+".destroy()\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the show<name> method\n# .........................................................\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write("   def show"+name+"(self, parent, parentWindow = None):\\n")\n   file.write(ind+"if self.label and self.widget:\\n")\n   file.write(ind+"   self.label.grid_forget()\\n")\n   file.write(ind+"   self.widget.grid_forget()\\n")\n\n   if node.getClass() == "LeafType":\n      directEditing = node.Type.getValue()[4][1]\n   else:\n      directEditing = 1\n\n   file.write(ind+"self.label = Label(self.containerFrame, text=\'"+name+"\')\\n")\n   file.write(ind+"self.label.grid(row=1,column=0,sticky=W)\\n")\n\n   if directEditing:\n      file.write(ind+"self.widget = self."+name+".show(self.containerFrame, self.parentWindowInfo)\\n")\n      file.write(ind+"self.widget.grid(row=1,column=1,sticky=W)\\n")\n   else:\n      file.write(ind+"Button( self.containerFrame, text = \'edit\', ")\n      file.write("command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x."+name+"))")\n      file.write(".grid(row=1,column=1,sticky=W)\\n")\n\n   file.write(ind+"self.lastSelected = \'"+name+"\'\\n")\n   file.write("\\n")\n# .........................................................\n# Generate the toString method\n# .........................................................\nfile.write("   def toString(self, fils = 25, cols = 5):\\n")\nfile.write(ind+"self.createComponents()\\n")\nfile.write(ind+"if self.selected:\\n")\nfile.write(ind+"   value = self.selected.get()\\n")\nfile.write(ind+"elif self.lastSelected:\\n")\nfile.write(ind+"   value = self.lastSelected\\n")   \nfile.write(ind+"else:\\n")\nfile.write(ind+"   value = None\\n")\ncounter = 0\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   if counter==0: file.write(ind+"if value == \'"+name+"\':\\n")\n   else:file.write(ind+"elif value == \'"+name+"\':\\n")\n   file.write(ind+"   return self."+name+".toString(fils, cols)\\n")\n   counter = counter + 1\nfile.write(ind+"return \'\'\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the getValue method\n# .........................................................\nfile.write("   def getValue(self):\\n")\nfile.write(ind+"self.createComponents()\\n")\nfile.write(ind+"return (")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write("self."+name+".getValue(),")\nfile.write(")\\n\\n")\n# .........................................................\n# Generate the setValue method\n# .........................................................\nfile.write("   def setValue(self, value):\\n")\nfile.write(ind+"self.createComponents()\\n")\nfile.write(ind+"if value == None:\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"   self."+name+".setNone()\\n")\nfile.write(ind+"else:\\n")\ncounter = 0\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"   self."+name+".setValue(value["+str(counter)+"])\\n")\n   counter = counter + 1\nfile.write("\\n")\n# .........................................................\n# Generate the writeConstructor2File method\n# .........................................................\nfile.write(\'   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):\\n\')\nfile.write(ind+"self.createComponents()\\n")\nfile.write(ind+"file.write(indent+objName+\'= "+className+"()\\\\n\')\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"self."+name+".writeConstructor2File(file, indent, objName+\'."+name+"\', depth, generatingCode)\\n")\nfile.write(ind+"if self.lastSelected:\\n")\nfile.write(ind+"   file.write(indent+objName+\'.lastSelected= "+\'"\'+"\'+self.lastSelected+\'"+\'"\'+"\'\\\\n\')\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the writeValue2File method\n# .........................................................\nfile.write(\'   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):\\n\')\nfile.write(ind+"self.createComponents()\\n")\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+"self."+name+".writeValue2File(file, indent, objName+\'."+name+"\', depth, generatingCode)\\n")\nfile.write(ind+"if self.lastSelected:\\n")\nfile.write(ind+"   file.write(indent+objName+\'.lastSelected= "+\'"\'+"\'+self.lastSelected+\'"+\'"\'+"\'\\\\n\')\\n")\nfile.write("\\n")\n# .........................................................\n# Generate the clone method\n# .........................................................\nfile.write(\'   def clone(self):\\n\')\nfile.write(ind+\'"Makes an exact copy of itself"\\n\')\nfile.write(ind+\'cloneObject = \'+className+\'()\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+\'if self.\'+name+\': cloneObject.\'+name+\' = self.\'+name+\'.clone()\\n\')\nfile.write(ind+\'cloneObject.lastSelected = self.lastSelected\\n\')\nfile.write(ind+\'return cloneObject\\n\')\n# .........................................................\n# Generate the copy method\n# ........................................................\nfile.write(\'   def copy(self, other):\\n\')\nfile.write(ind+\'"Copies the content of other into itself"\\n\')\nfile.write(ind+\'ATOM3Type.copy(self, other)\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+\'self.\'+name+\' = other.\'+name+\'\\n\')\nfile.write(ind+\'ASGNode.copy(self,other)\\n\')\n# .........................................................\n# Generate the destroy method\n# .........................................................\nfile.write(\'   def destroy(self):\\n\')\nfile.write(ind+\'"Destroys (i.e. updates) each field"\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element # unpack element components\n   file.write(ind+\'if self.\'+name+\': self.\'+name+\'.destroy()\\n\')\nfile.write(\'\\n\\n\')\n# .........................................................\n# Generate the invalid method\n# .........................................................\nfile.write(\'   def invalid(self):\\n\')\nfile.write(\'     "checks whether the entity is valid or not"\\n\')\nfile.write(\'     inval = 0\\n\')\nfor element in attributesInfo:					# for each element in attributesInfo...\n   name, type, valInitial, node = element                         # unpack element components\n   file.write(\'     if self.\'+name+\': inval = inval or self.\'+name+\'.invalid()\')\nfile.write(\'     return inval\\n\\n\')\nfile.close()\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('TypeGen')
   cobj0.Order=ATOM3Integer(2)

   from ASG_TypesMetaModel import *
   from Operator import *
   from TypeName import *
   from LeafType import *

   cobj0.LHS = ASG_TypesMetaModel(self)

   self.obj36=TypeName(self)

   self.obj36.Name.setValue('')
   self.obj36.GGLabel.setValue(1)
   self.obj36.graphClass_= graph_TypeName
   if self.genGraphics:
      from graph_TypeName import *
      new_obj = graph_TypeName(207.0,272.0,self.obj36)
   else: new_obj = None
   self.obj36.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj36)
   cobj0.RHS = ASG_TypesMetaModel(self)

   self.obj38=TypeName(self)

   self.obj38.Name.setValue('typename0')
   self.obj38.GGLabel.setValue(1)
   self.obj38.graphClass_= graph_TypeName
   if self.genGraphics:
      from graph_TypeName import *
      new_obj = graph_TypeName(211.0,254.0,self.obj38)
   else: new_obj = None
   self.obj38.graphObject_ = new_obj
   self.obj380= AttrCalc()
   self.obj380.Copy=ATOM3Boolean()
   self.obj380.Copy.setValue(('Copy from LHS', 1))
   self.obj380.Copy.config = 0
   self.obj380.Specify=ATOM3Constraint()
   self.obj380.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj38.GGset2Any['Name']= self.obj380
   cobj0.RHS.addNode(self.obj38)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '"Condition that must be satisfied for the rule to be applicable on the isograph"\n# we can have multiple matches of the rule!\nnode = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\nif node.FILE_!=isograph[0].Name.toString():                # This node has been processed yet!\n   return 0\n\nself.generatedChilds = []\nfor child in node.out_connections_:			# All childs must have the FILE_ slot filled...\n   if child.FILE_:						# if this is the case, add to list\n      self.generatedChilds.append(child)\n   else:\n      return 0							# otherwise, the condition does not hold...\nreturn 1	\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# compose the class name\nnode = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\nclassName = node.FILE_\nchildNode = node.out_connections_[0]                       # get child node\nfileName = className+".py"\nfile = open(atom3i.codeGenDir+"/"+fileName, "w+t")			\nfile.write("from Tkinter             import *\\n")                              \nfile.write("from ATOM3Type           import *\\n")\nfile.write("from Operator            import *\\n")\nfile.write("from LeafType             import *\\n")\nfile.write("from TypeName            import *\\n")\nfile.write("from ASG_TypesMetaModel import *\\n")\n# generate imports...\nfile.write("from "+childNode.FILE_+" import *\\n\\n")\nfile.write("class "+className+" ("+childNode.FILE_+"):\\n")\nfile.write("  def createTypeGraph(self, atom3i, rootNode):\\n")\nnode.rootNode.writeGraph2File(file, parentName="atom3i")\nfile.write("\\n")\nfile.close()\nnode.FILE_= None\n\n\n\n\n\n\n'))
   lcobj0.append(cobj0)
   self.EditingGraphGrammar.Rules.setValue(lcobj0)
   self.EditingGraphGrammar.InitialAction=ATOM3Constraint()
   self.EditingGraphGrammar.InitialAction.setValue(('constraint', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# create the slot "FILE_" in each node of the graph...\nfor tip in graph.listNodes.keys():\n  for node in graph.listNodes[tip]:\n    if tip == "LeafType" :	# fill the slot, tuple (name, type)\n      node.FILE_ = ( node.Type.getValue()[0] ,\'ATOM3\'+node.Type.getValue()[1])\n    elif tip == "TypeName":\n      node.FILE_ = node.Name.toString()\n    else:\n      node.FILE_ = None\n'))
   self.EditingGraphGrammar.FinalAction=ATOM3Constraint()
   self.EditingGraphGrammar.FinalAction.setValue(('const', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'for tip in graph.listNodes.keys():\n  for node in graph.listNodes[tip]:\n    del node.FILE_\n\n'))


